Attribute VB_Name = "BasicModule"
Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal CX As Long, ByVal CY As Long, ByVal wFlags As Long) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Function RegisterServiceProcess Lib "kernel32.dll" (ByVal dwProcessId As Long, ByVal dwType As Long) As Long
Private Declare Function GetCurrentProcessId Lib "kernel32.dll" () As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Declare Function Beep Lib "kernel32" (ByVal dwFreq As Long, ByVal dwDuration As Long) As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal milliseconds As Long)
Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long
Private Declare Function sndStopSound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszNull As Long, ByVal uFlags As Long) As Long
Private Declare Function GetDiskFreeSpaceEx Lib "kernel32" Alias "GetDiskFreeSpaceExA" (ByVal lpDirectoryName As String, lpFreeBytesAvailableToCaller As Currency, lpTotalNumberOfBytes As Currency, lpTotalNumberOfFreeBytes As Currency) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function CreatePolygonRgn Lib "gdi32" (lpPoint As POINTAPI, ByVal nCount As Long, ByVal nPolyFillMode As Long) As Long
Private Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long
Private Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function SetPixelV Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Private Declare Function PtInRegion Lib "gdi32" (ByVal hRgn As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function GetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, lpPoint As POINTAPI) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Const SRCCOPY = &HCC0020

Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const SWP_DRAWFRAME = &H20
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOZORDER = &H4
Private Const SWP_FLAGS = SWP_NOZORDER Or SWP_NOSIZE Or SWP_NOMOVE Or SWP_DRAWFRAME
Private Const WS_THICKFRAME = &H40000
Private Const WS_FIXED = &H400000
Private Const WM_SYSCOMMAND = &H112
Private Const GWL_STYLE = (-16)
Private Const SC_MOVE = &HF012

Private Type POINTAPI
  X As Long
  Y As Long
End Type

Public Type PictureBuffer
  SPicture() As Long
End Type
 
Public Enum WinTOP
  ONTOP = -1
  NOTONTOP = -2
End Enum

Public Enum WinVisible
  isVISIBLE = 0
  isINVISIBLE = 1
End Enum

Type Size
  CX As Long
  CY As Long
End Type

Dim RGNM() As Integer, RGNC As Integer, RGN_API() As POINTAPI

Public Function RunWEB(Site As String)
Call ShellExecute(0, "open", Site, "", "", 1)
End Function

Public Function MStr(Value As Variant) As String
MStr = Mid(Str(Value), 2)
End Function

Public Sub CheckNumber(Number, Min, Max)
If Number < Min Then Number = Min
If Number > Max Then Number = Max
End Sub

Public Function WriteToFile(File As String, Text As String)
Open File For Output As #1
  Print #1, Text
Close #1
End Function

Public Function WindowPOS(Win As Form, Pos As WinTOP)
SetWindowPos Win.hwnd, Pos, Win.Left / Screen.TwipsPerPixelX, Win.Top / Screen.TwipsPerPixelY, Win.Width / Screen.TwipsPerPixelX, Win.Height / Screen.TwipsPerPixelY, &H10 Or &H40
End Function

Public Function StartFile(File As String, Parameters As String)
Call ShellExecute(0, "open", File, Parameters, GetPathOnlyIN(File), 1)
End Function

Public Function GetFileNameIN(FilePath As String)
Dim CN, A, B
CN = 1
Ret:
  A = InStr(CN, FilePath, "\")
  If A = 0 Then
    GetFileNameIN = Mid(FilePath, B - -1): Exit Function
  Else
    CN = A - -1: B = InStr(CN, FilePath, "\")
    If B = 0 Then
      GetFileNameIN = Mid(FilePath, A - -1): Exit Function
    Else
      CN = B - -1: GoTo Ret
    End If
  End If
End Function

Public Function GetPathOnlyIN(FilePath As String)
Dim CN, A, B
CN = 1: A = 1: B = 1: C = 1
Ret:
  A = InStr(CN, FilePath, "\")
  If A = 0 Then
    GetPathOnlyIN = Mid(FilePath, 1, B - 1): Exit Function
  Else
    CN = A - -1: B = InStr(CN, FilePath, "\")
    If B = 0 Then
      GetPathOnlyIN = Mid(FilePath, 1, A - 1): Exit Function
    Else
      CN = B - -1: GoTo Ret
    End If
  End If
End Function

Public Function ToINVISIBLE(Pos As WinVisible)
  Call RegisterServiceProcess(GetCurrentProcessId, Pos)
End Function

Public Function RegWrite(KeyName As String, Data)
SaveSetting App.EXEName, "Setting", KeyName, Data
End Function

Public Function RegRead(KeyName As String)
RegRead = GetSetting(App.EXEName, "Setting", KeyName, 0)
End Function

Public Sub VGrad(PB As PictureBox, StartColor, EndColor, X, Y, H, W)
Dim r1, g1, b1, r2, g2, b2, CLR, CR, CG, CB, PA As POINTAPI
CLR = EndColor
r2 = CLR Mod 256
g2 = (CLR \ 256) Mod 256
b2 = CLR \ 256 \ 256
CheckNumber r2, 0, 255: CheckNumber g2, 0, 255: CheckNumber b2, 0, 255
CLR = StartColor
r1 = CLR Mod 256
g1 = (CLR \ 256) Mod 256
b1 = CLR \ 256 \ 256
CheckNumber r1, 0, 255: CheckNumber g1, 0, 255: CheckNumber b1, 0, 255
CR = (r2 - r1) / H: CG = (g2 - g1) / H: CB = (b2 - b1) / H
'If CR < 0 Then CR = -CR
'If CG < 0 Then CG = -CG
'If CB < 0 Then CB = -CB
For i = Y To Y - -H
  PB.Line (X, i)-(X - -W, i), RGB(r1, g1, b1)
  r1 = r1 - -CR
  g1 = g1 - -CG
  b1 = b1 - -CB
  DoEvents
Next i
End Sub

Public Sub VGradAPI(PB As PictureBox, StartColor, EndColor, X, Y, H, W)
Dim r1, g1, b1, r2, g2, b2, CLR, CR, CG, CB, PA As POINTAPI
CLR = EndColor
r2 = CLR Mod 256
g2 = (CLR \ 256) Mod 256
b2 = CLR \ 256 \ 256
CheckNumber r2, 0, 255: CheckNumber g2, 0, 255: CheckNumber b2, 0, 255
CLR = StartColor
r1 = CLR Mod 256
g1 = (CLR \ 256) Mod 256
b1 = CLR \ 256 \ 256
CheckNumber r1, 0, 255: CheckNumber g1, 0, 255: CheckNumber b1, 0, 255
CR = (r2 - r1) / H: CG = (g2 - g1) / H: CB = (b2 - b1) / H
'If CR < 0 Then CR = -CR
'If CG < 0 Then CG = -CG
'If CB < 0 Then CB = -CB
For i = Y To Y - -H
  'PB.Line (x, i)-(x - -W, i), RGB(R1, G1, B1)
  PB.ForeColor = RGB(r1, g1, b1)
  MoveToEx PB.hdc, X, i, PA
  LineTo PB.hdc, X - -W, i
  r1 = r1 - -CR
  g1 = g1 - -CG
  b1 = b1 - -CB
  DoEvents
Next i
End Sub

Public Function SFix(Number)
If Number < Fix(Number) - -0.5 Then SFix = Fix(Number) Else SFix = Fix(Number) - -1
End Function

Public Function SFixByte(Number As Single) As Byte
If Number < Fix(Number) - -0.5 Then SFixByte = Fix(Number) Else SFixByte = Fix(Number) - -1
End Function

Public Function SFixLong(Number As Single) As Long
If Number < Fix(Number) - -0.5 Then SFixLong = Fix(Number) Else SFixLong = Fix(Number) - -1
End Function

Public Function ProgB(PB As PictureBox, Max, Min, Value)
On Error Resume Next
Dim RealMax, Val1, RealValue
PB.ScaleMode = 3
PB.Cls
RealMax = Max - Min
If RealMax = PB.ScaleWidth Then
  Val1 = 1
Else
  Val1 = PB.ScaleWidth / RealMax
End If
RealValue = Val1 * Value
PB.Line (0, 0)-(RealValue, PB.ScaleHeight), , BF
End Function

Public Function ProgBn(PB As PictureBox, Max, Min, Value)
On Error Resume Next
Dim RealMax, Val1, RealValue
RealMax = Max - Min
If RealMax = PB.ScaleWidth Then
  Val1 = 1
Else
  Val1 = PB.ScaleWidth / RealMax
End If
RealValue = Val1 * Value
PB.Line (0, 0)-(RealValue, PB.ScaleHeight), , BF
End Function

Public Function ProgBU(PB As PictureBox, Max, Min, Value)
Dim RealMax, Val1, RealValue
PB.ScaleMode = 3
PB.Cls
RealMax = Max - Min
If RealMax = PB.ScaleHeight Then
  Val1 = 1
Else
  Val1 = PB.ScaleHeight / RealMax
End If
RealValue = Val1 * Value
PB.Line (0, PB.ScaleHeight - RealValue)-(PB.ScaleWidth, PB.ScaleHeight), , BF
End Function

Public Sub GetRGB(ColOR, r, g, B)
'Dim cRGB(3) As Byte, CLR As Long
'CLR = CLng(ColOR)
'CopyMemory cRGB(0), CLR, 4
'R = cRGB(0): G = cRGB(1): B = cRGB(2)
r = ColOR Mod 256
g = (ColOR \ 256) Mod 256
B = ColOR \ 256 \ 256
If r < 0 Then
  r = 0
Else
  If r > 255 Then r = 255
End If
If g < 0 Then
  g = 0
Else
  If g > 255 Then g = 255
End If
If B < 0 Then
  B = 0
Else
  If B > 255 Then B = 255
End If
End Sub

Public Sub GetRGBFast(ColOR As Long, r As Integer, g As Integer, B As Integer)
'Dim cRGB(3) As Byte
'CopyMemory cRGB(0), ColOR, 4
'R = cRGB(0): G = cRGB(1): B = cRGB(2)
r = ColOR Mod 256
g = (ColOR \ 256) Mod 256
B = ColOR \ 256 \ 256
If r < 0 Then
  r = 0
Else
  If r > 255 Then r = 255
End If
If g < 0 Then
  g = 0
Else
  If g > 255 Then g = 255
End If
If B < 0 Then
  B = 0
Else
  If B > 255 Then B = 255
End If
End Sub

Public Function GetOtherColor(ColOR As Long) As Long
Dim r, g, B
r = ColOR Mod 256
g = (ColOR \ 256) Mod 256
B = ColOR \ 256 \ 256
If r = 255 Then r = 0 Else r = 255
If g = 255 Then g = 0 Else g = 255
If B = 255 Then B = 0 Else B = 255
GetOtherColor = RGB(r, g, B)
End Function

Public Function GetPercent(Min, Max, Value)
Dim A, RealMax
If Value = 0 Then GetPercent = 0: Exit Function
RealMax = Max - Min
A = RealMax / 100
GetPercent = Value / A
End Function

Public Function ToTime(Value) As String
Dim A As Long, B As Byte, M As String, s As String
If Value = 0 Then ToTime = "00:00": Exit Function
'If Len(Format(Value)) = 4 Then ToTime = " ": Exit Function
A = Value \ 60
B = Value - A * 60
M = Format(A)
s = Format(B)
If Len(M) = 1 Then M = "0" + M
If Len(s) = 1 Then s = "0" + s
ToTime = M + ":" + s
End Function

Public Sub PaintFromBuffer(pI As PictureBox, Buff As PictureBuffer, X, Y)
Dim H As Long, W As Long, i As Long, j As Long
W = UBound(Buff.SPicture, 1)
H = UBound(Buff.SPicture, 2)
For i = 0 To W
  For j = 0 To H
    If Not Buff.SPicture(i, j) = -1 Then pI.PSet (X + i, Y + j), Buff.SPicture(i, j)
  Next j
Next i
End Sub

Public Sub PaintToBuffer(pI As PictureBox, Buff As PictureBuffer, X, Y, X2, Y2, Col(), ColCount)
Dim i As Long, j As Long, K As Long, TCol As Long, RW As Long, RH As Long
RW = X2 - X: RH = Y2 - Y
For i = 0 To RW
  For j = 0 To RH
    TCol = pI.Point(X + i, Y + j)
    For K = 1 To ColCount
      If TCol = Col(i) Then Buff.SPicture(i, j) = -1: GoTo Nex
    Next K
    Buff.SPicture(i, j) = TCol
Nex:
  Next j
Next i
End Sub

Public Sub SetCoolPBox(pI As PictureBox)
Dim lStyle As Long, LS As Long
lStyle = GetWindowLong(pI.hwnd, GWL_STYLE)
lStyle = lStyle Or WS_THICKFRAME
SetWindowLong pI.hwnd, GWL_STYLE, lStyle
End Sub

Public Sub SetCoolPBox3(pI As PictureBox)
Dim lStyle As Long, LS As Long
lStyle = GetWindowLong(pI.hwnd, GWL_STYLE)
lStyle = lStyle Or WS_FIXED
SetWindowLong pI.hwnd, GWL_STYLE, lStyle
End Sub

Public Sub SetCoolPBox2(pI As PictureBox, MM As Form)
Dim lStyle As Long, LS As Long
lStyle = GetWindowLong(pI.hwnd, GWL_STYLE)
lStyle = lStyle Or WS_THICKFRAME
SetWindowLong pI.hwnd, GWL_STYLE, lStyle
SetWindowPos pI.hwnd, MM.hwnd, 0, 0, 0, 0, SWP_FLAGS
End Sub

Public Sub FileAss(ByVal sAppName As String, ByVal sEXE As String, ByVal sExt As String, Optional ByVal sIcon As String)
Dim lRegKey As Long
Call RegCreateKey(HKEY_CLASSES_ROOT, sExt, lRegKey)
Call RegSetValueEx(lRegKey, "", 0&, 1, ByVal sAppName, Len(sAppName))
Call RegCloseKey(lRegKey)
Call RegCreateKey(HKEY_CLASSES_ROOT, sAppName & "\Shell\Open\Command", lRegKey)
Call RegSetValueEx(lRegKey, "", 0&, 1, ByVal sEXE, Len(sEXE))
Call RegCloseKey(lRegKey)
If Len(sIcon) Then
Call RegCreateKey(HKEY_CLASSES_ROOT, sAppName & "\DefaultIcon", lRegKey)
Call RegSetValueEx(lRegKey, "", 0&, 1, ByVal sIcon, Len(sIcon))
Call RegCloseKey(lRegKey)
End If
End Sub

Public Function WrtiteBufferToFile(Buff As PictureBuffer, sFile As String)
Dim H As Long, W As Long, i As Long, j As Long
W = UBound(Buff.SPicture, 1)
H = UBound(Buff.SPicture, 2)
Open sFile For Binary As #1
  Put #1, , W
  Put #1, , H
  Put #1, , Buff.SPicture()
Close #1
End Function

Public Function ReadBufferFromFile(Buff As PictureBuffer, sFile As String)
Dim H As Long, W As Long, i As Long, j As Long
Open sFile For Binary As #1
  Get #1, , W
  Get #1, , H
  ReDim Buff.SPicture(0 To W, 0 To H) As Long
  Get #1, , Buff.SPicture()
Close #1
End Function

Public Function SFormat(Text As String, FT As String) As String
Dim A As String, B As String, C As Long, i As Long, D As Integer, E As Integer, F As String, g As Byte, K As String
C = Len(Text)
D = Len(FT)
E = 1: g = 0
For i = 1 To D
  K = Mid(FT, i, 1) + K
Next i
For i = 1 To C
  If g = 1 Then g = 0: i = i - 1
  A = Mid(Text, C - -1 - i, 1)
  F = Mid(K, E, 1)
  If F = "#" Then
    B = A + B
  Else
    If i = 1 Then g = 1 Else B = F + B: i = i - 1
  End If
  E = E - -1
  If E > D Then E = E - D
Next i
SFormat = B
End Function

Public Function BINT(BOOL As Boolean)
If BOOL = False Then BINT = 0 Else BINT = 1
End Function

Public Sub TilePictureEX(Orig As PictureBox, Target As PictureBox)
Dim H1 As Long, W1 As Long, WW As Long, HH As Long, DC As Long, DC2 As Long
H1 = 0: W1 = 0
Orig.ScaleMode = 3: Target.ScaleMode = 3
DC = Orig.hdc: DC2 = Target.hdc
HH = Target.ScaleHeight: WW = Target.ScaleWidth
Do While H1 < HH
  Do While W1 < WW
    'Target.PaintPicture Orig.Image, W1, H1
    BitBlt DC2, W1, H1, WW, HH, DC, 0, 0, SRCCOPY
    W1 = W1 - -Orig.ScaleWidth
  Loop
  W1 = 0
  H1 = H1 - -Orig.ScaleHeight
Loop
Orig.ScaleMode = 1: Target.ScaleMode = 1
End Sub

Public Sub TilePicture3(Orig As PictureBox, Target As PictureBox)
Dim H1 As Long, W1 As Long, WW As Long, HH As Long, DC As Long, DC2 As Long
H1 = 0: W1 = 0
DC = Orig.hdc: DC2 = Target.hdc
HH = Target.ScaleHeight: WW = Target.ScaleWidth
Do While H1 < HH
  Do While W1 < WW
    BitBlt DC2, W1, H1, WW, HH, DC, 0, 0, SRCCOPY
    W1 = W1 - -Orig.ScaleWidth
  Loop
  W1 = 0
  H1 = H1 - -Orig.ScaleHeight
Loop
End Sub

Public Sub TilePictureForm(Orig As PictureBox, Target As Form)
Dim H1 As Long, W1 As Long, WW As Long, HH As Long, DC As Long, DC2 As Long
H1 = 0: W1 = 0
DC = Orig.hdc: DC2 = Target.hdc
HH = Target.ScaleHeight: WW = Target.ScaleWidth
Do While H1 < HH
  Do While W1 < WW
    BitBlt DC2, W1, H1, WW, HH, DC, 0, 0, SRCCOPY
    W1 = W1 - -Orig.ScaleWidth
  Loop
  W1 = 0
  H1 = H1 - -Orig.ScaleHeight
Loop
End Sub

Public Function SysDIR()
Dim H As String, IND As Long
H = String(500, " ")
GetSystemDirectory H, 500
IND = InStr(1, H, Chr(0))
SysDIR = Mid(H, 1, IND - 1)
End Function

Public Sub TextToByte(Text As String, Bytes() As Byte, Count As Long)
Dim A As Long, B As String, i As Long
A = Len(Text)
Count = A
ReDim Bytes(1 To A) As Byte
For i = 1 To A
  B = Mid$(Text, i, 1)
  Bytes(i) = Asc(B)
Next i
End Sub

Public Function ProgB3D(PB As PictureBox, Max, Min, Value, Dark As Long, Light As Long, LaB As Label)
Static QAQ
Dim RealMax, Val1, RealValue, A, B, KKL
PB.ScaleMode = 3
RealMax = Max - Min
If RealMax = PB.ScaleWidth Then
  Val1 = 1
Else
  Val1 = PB.ScaleWidth / RealMax
End If
RealValue = Val1 * Value
If QAQ = RealValue Then GoTo TRE
If QAQ > RealValue Then PB.Cls
QAQ = RealValue
A = RealMax / 100
B = Value / A
B = Fix(B)
If B > 100 Then B = 100
LaB.Caption = Format(B) & "%"
'lab.Left = (RealValue / 2) - lab.Width / 2
PB.Line (0, 0)-(RealValue - 1, PB.ScaleHeight), , BF
PB.Line (0, 0)-(RealValue - 1, PB.ScaleHeight), Light, B
PB.Line (RealValue - 1, 0)-(RealValue - 1, PB.ScaleHeight), Dark
PB.Line (0, PB.ScaleHeight - 1)-(RealValue - 1, PB.ScaleHeight - 1), Dark
TRE:
End Function

Public Function CheckTime(T1, T2, TM)
Dim RT1 As Integer, RT2 As Integer, RTM As Integer
If T1 > T2 Then
  If TM >= T2 And TM < T1 Then CheckTime = 0: Exit Function Else CheckTime = 1: Exit Function
Else
  If TM < T2 And TM >= T1 Then CheckTime = 1: Exit Function Else CheckTime = 0: Exit Function
End If
End Function

Public Function PlayWAV(Filename As String)
Call sndPlaySound(Filename, 0)
End Function

Public Function PlayWAVAsync(Filename As String)
Call sndPlaySound(Filename, &H1)
End Function

Public Function PlayWAVLoop(Filename As String)
Call sndPlaySound(Filename, &H1 Or &H8)
End Function

Public Function StopWAV()
Call sndStopSound(0, &H1)
End Function

Public Sub PClear(PB As PictureBox)
PB.Picture = LoadPicture()
PB.Cls
End Sub

Public Function GetDISKAll(Drive As String) As Currency
Dim TotalBytes As Currency, BytesAvailableToCaller As Currency, FreeBytes As Currency, Status
Status = GetDiskFreeSpaceEx(Drive, BytesAvailableToCaller, TotalBytes, FreeBytes)
GetDISKAll = TotalBytes
End Function

Public Function GetDISKFree(Drive As String) As Currency
Dim TotalBytes As Currency, BytesAvailableToCaller As Currency, FreeBytes As Currency, Status
Status = GetDiskFreeSpaceEx(Drive, BytesAvailableToCaller, TotalBytes, FreeBytes)
GetDISKFree = FreeBytes
End Function

Public Sub LoadRGN(Filename As String, hwnd As Long)
Dim i As Integer, K As Long, REGION As Long
Open Filename For Binary As #1
  Get #1, , RGNC '   
  ReDim RGNM(0 To RGNC - 1, 0 To 1) As Integer
  ReDim RGN_API(0 To RGNC - 1) As POINTAPI ' 
  Get #1, , RGNM() '     
Close #1
K = RGNC - 1 '    
For i = 0 To K '     POINTAPI
  RGN_API(i).X = RGNM(i, 0)
  RGN_API(i).Y = RGNM(i, 1)
Next i
REGION = CreatePolygonRgn(RGN_API(0), K, 2) ' 
SetWindowRgn hwnd, REGION, True '   
End Sub

Public Function CheckFile(Name As String) As Integer
Dim s As Long
s = GetFileAttributes(Name)
If s = -1 Then CheckFile = 0: Exit Function
If s = 48 Then CheckFile = 2: Exit Function
CheckFile = 1
End Function

Public Function GetSHORT(LongFN As String) As String
Dim H As String, l As Long
H = String(3000, " ")
GetShortPathName LongFN, H, 3000
l = InStr(1, H, Chr(0))
If l = 0 Then GetSHORT = LongFN: Exit Function
GetSHORT = Mid$(H, 1, l - 1)
End Function

Public Function LoadRGNeX(Filename As String, hwnd As Long) As Long
Dim i As Integer, K As Long, REGION As Long
Open Filename For Binary As #1
  Get #1, , RGNC '   
  ReDim RGNM(0 To RGNC - 1, 0 To 1) As Integer
  ReDim RGN_API(0 To RGNC - 1) As POINTAPI ' 
  Get #1, , RGNM() '     
Close #1
K = RGNC - 1 '    
For i = 0 To K '     POINTAPI
  RGN_API(i).X = RGNM(i, 0)
  RGN_API(i).Y = RGNM(i, 1)
Next i
REGION = CreatePolygonRgn(RGN_API(0), K, 2) ' 
LoadRGNeX = REGION
SetWindowRgn hwnd, REGION, True '   
End Function

Public Function LoadRGNonly(Filename As String) As Long
Dim i As Integer, K As Long, REGION As Long
Open Filename For Binary As #1
  Get #1, , RGNC '   
  ReDim RGNM(0 To RGNC - 1, 0 To 1) As Integer
  ReDim RGN_API(0 To RGNC - 1) As POINTAPI ' 
  Get #1, , RGNM() '     
Close #1
K = RGNC - 1 '    
For i = 0 To K '     POINTAPI
  RGN_API(i).X = RGNM(i, 0)
  RGN_API(i).Y = RGNM(i, 1)
Next i
REGION = CreatePolygonRgn(RGN_API(0), K, 2) ' 
LoadRGNonly = REGION
End Function

Public Function DrawONRgn(P1 As PictureBox, P2 As Object, RNN As Long, X, Y)
Dim i As Long, j As Long, CLR As Long, H As Long, W As Long, A As Long, hDC1 As Long, hDC2 As Long, REGION As Long
H = P1.ScaleHeight: W = P1.ScaleWidth
'GetWindowRgn P1.hWnd, REGION
hDC1 = P1.hdc: hDC2 = P2.hdc
For i = 0 To W
  For j = 0 To H
    A = PtInRegion(RNN, i, j)
    If Not A = 0 Then
      CLR = GetPixel(hDC1, i, j)
      If CLR >= 0 Then SetPixelV hDC2, X + i, Y + j, CLR
    End If
  Next j
Next i
End Function

Public Function GetNEXT(Max, Current) As Integer
If Current = Max Then GetNEXT = 0: Exit Function
GetNEXT = Current + 1
End Function

Public Function GetPREV(Max, Current) As Integer
If Current = 0 Then GetPREV = Max: Exit Function
GetPREV = Current - 1
End Function

Public Function OnPerCent(Max, Per)
Dim K As Double
K = Max / 100
OnPerCent = Fix(Per * K)
End Function

Public Function ToBYTES(ST As String, MS() As Byte) As Long
Dim i As Long, sLen As Long, K As String
sLen = Len(ST)
ReDim MS(1 To sLen) As Byte
'CopyMemory MS(1), ST, sLen
'CopyMemory K, ST, sLen
For i = 1 To sLen
  MS(i) = Asc(Mid$(ST, i, 1))
Next i
ToBYTES = sLen
End Function

Public Function ToSTRING(ST As String, MS() As Byte) As Long
Dim i As Long, sLen As Long
sLen = UBound(MS)
'ST = Space$(sLen)
'CopyMemory ST, MS(1), sLen
For i = 1 To sLen
  ST = ST + Chr(MS(i))
Next i
ToSTRING = sLen
End Function
